//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#include <filectrl.hpp>
#include <sysutils.hpp>
#pragma hdrstop

#include "UninstDlg.h"
#include "Global.h"
#include "FileMan.h"
#include "WaitDlg.h"
#include "setupdlg.h" // for MixKey var
#include "setupver.h"
//#include "uninstdirdlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TUninstWiz *UninstWiz;
//---------------------------------------------------------------------------
__fastcall TUninstWiz::TUninstWiz(TComponent* Owner)
  : TForm(Owner)
{
  const AnsiString MenuString = "About Uninstall...";
  MENUITEMINFO info = {  sizeof(MENUITEMINFO),
                         MIIM_TYPE | MIIM_STATE | MIIM_ID ,
                         MFT_STRING,                 // menu type is string
                         MFS_ENABLED,                // menu item is enabled
                         IDS_CUSTOMSYSMENUITEM,  // id of menu item
                         NULL,                       // no sub menu
                         NULL,                       // no check bitmap
                         NULL,                       // no uncheck bitmap
                         0,                          // no item data
                         MenuString.c_str(),         // string of menu item
                         0};                         // last item not used
  MENUITEMINFO sepr = {  sizeof(MENUITEMINFO),
                         MIIM_TYPE | MIIM_STATE | MIIM_ID ,
                         MFT_SEPARATOR,                 // menu type is string
                         MFS_ENABLED,                // menu item is enabled
                         0,  // id of menu item
                         NULL,                       // no sub menu
                         NULL,                       // no check bitmap
                         NULL,                       // no uncheck bitmap
                         0,                          // no item data
                         NULL,                       // string of menu item
                         0};                         // last item not used
  // obtain the menu handle for the system menu
  HMENU SysMenu = GetSystemMenu(Handle, FALSE);
  // Insert the new menu item just after the close menu item. If the TRUE
  InsertMenuItem (SysMenu, SC_CLOSE, TRUE, &sepr);
  InsertMenuItem (SysMenu, 5, false, &info);

   // init some values
   Notebook->PageIndex = 0;

   TRegistry *reg = new TRegistry();
   mixkeyexists = reg->KeyExists(MixKey);
   appkeyexists = reg->KeyExists(QuickKey);
   if (!appkeyexists && !mixkeyexists)
   {
      delete reg;
      NextBtn->Enabled = false;
      RichEdit7->Lines->Text =
         "Neither QuickSilver nor Mixmaster are installed on this machine!\nNothing to un-install!";
      //Appname->Visible =
      Label24->Visible = false;
      Appname->Caption = "QuickSilver";
      Label23->Caption = "by Benchmark Software";
      CancelBtn->Caption = "Bye!";
      CancelBtn->Default = true;
      NextBtn->Default = false;
      ActiveControl = Panel1;
      return;
   }
   if (reg->OpenKey(MixKey,false))
   {
      mixdir = AddBackslash(reg->ReadString("MixDir"));
      reg->CloseKey();
   }
   if (reg->OpenKey(QuickKey,false))
   {
      appdir = AddBackslash(reg->ReadString("AppDir"));
      proggroup = reg->ReadString("Program Group");
      releasever = reg->ReadString("Version");
      reg->CloseKey();
   }
   delete reg;

   AppEntries->Caption = AppName;
   MixEntries->Caption = "Mixmaster";
   Appname->Caption = AppName+" "+releasever;
   Label25->Caption = "Un-Install "+AppName;

   // disable checkboxes that don't apply
   if (!mixkeyexists) TurnOff(MixEntries);
   if (!appkeyexists || FileExists(appdir+"unqs.dsk")) TurnOff(AppEntries);
   if (appkeyexists && !FileExists(appdir+"unqs.dsk")) AppEntries->Checked = true;
   if (mixkeyexists) MixEntries->Checked = true;

   if (MixInApp() || MixIsApp()) MixEntries->Enabled = false;
   if (AppInMix()) AppEntries->Checked = true;
   NextBtn->Enabled = MixEntries->Checked || AppEntries->Checked;

   AnsiString notinstalled = "not installed";
   AnsiString mixcap = mixkeyexists ? RemoveBackslash(mixdir) : notinstalled;
   AnsiString appcap = appkeyexists ? RemoveBackslash(appdir) : notinstalled;
   MixEntries->Caption = MixEntries->Caption+"    { "+mixcap.LowerCase()+" }";
   AppEntries->Caption = AppEntries->Caption+"  { "+appcap.LowerCase()+" }";

   doappfirst = AppEntries->Checked && (!domixfirst && (MixIsApp() || !AppInMix()));
   domixfirst = MixEntries->Checked && (MixIsSep() ||  MixInApp());
   QSdone = MXdone = false;
   ActiveControl = Panel1;
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::WMSysCommand(TWMSysCommand &Msg)
{
  if(Msg.CmdType==IDS_CUSTOMSYSMENUITEM)
  {
     MsgBoxHwnd(Handle,UninsName+"  "+ReleaseVer+"\n"+CopyRight,"About...",MB_OK);
     Msg.Result = true;
  }
  else TForm::Dispatch(&Msg);
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::NextBtnClick(TObject *Sender)
{
   if (Notebook->ActivePage=="Review" && MsgBoxHwnd(Handle,"Uninstall now?",AppName,MB_OKCANCEL)==IDOK)
   {
      if (DoWaitDlg(AppName,"...uninstalling software...",this))
      {
         Notebook->PageIndex++;
         Application->ProcessMessages();
         RemoveSoftware();
         CancelBtn->Enabled = false;
         NextBtn->Caption = "Finish";
      }
      return;
   }
   if (Notebook->ActivePage=="Finish") // before set redraw
   {
      AnsiString cap = Caption; Caption = ""; AppProcessMessages(); Sleep(300);
      Caption = "working..."; AppProcessMessages(); Sleep(300);
      Caption = ""; AppProcessMessages(); Sleep(300);
      Caption = "working..."; AppProcessMessages(); Sleep(300);
      Caption = cap;
   }
   SetRedraw(this,0);
   if (Notebook->ActivePage=="Finish") // after redraw
   {
      if (QSdone && MXdone)  Label7->Caption = "QuickSilver and Mixmaster have been successfully uninstalled, but you will need to manually delete the QS database, the QS uninstall program and the QS home directory."; else
      if (QSdone) Label7->Caption = "QuickSilver has been successfully uninstalled, but you will need to manually delete the QS database, the QS uninstall program and the QS home directory."; else
      if (MXdone) Label7->Caption = "Mixmaster has been successfully uninstalled. Thanks very much for your interest in QuickSilver.";
      Label9->Visible = QSdone;
   }
   Notebook->PageIndex++;
   AnsiString Page = Notebook->ActivePage;
   if (Page=="Review") LoadReview();
   NextBtn->Caption = Page=="Finish" ? "Finish" : "Next";
   BackBtn->Enabled = Page=="Start" ? false : true;
   if (Page=="Final")
   {
      Label3->Caption = Appname->Caption;
      CancelBtn->Caption = "Exit";
      CancelBtn->Enabled = true;
      CancelBtn->Default = true;
      NextBtn->Default = false;
      NextBtn->Enabled = false;
      BackBtn->Enabled = false;
      ActiveControl = Panel1;
   }
   //if (locked) LockWindowUpdate(0);
   SetRedraw(this,1);
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::BackBtnClick(TObject *Sender)
{
   SetRedraw(this,0);
   //bool locked=LockWindowUpdate(Handle);
   Notebook->PageIndex--;
   AnsiString Page = Notebook->ActivePage;
   NextBtn->Caption = "Next";// /*Page=="Review" ||*/ Page=="Final" ? "Finish" : "Next";
   BackBtn->Enabled = Page=="Start" ? false : true;
   //if (locked) LockWindowUpdate(0);
   SetRedraw(this,1);
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (!appkeyexists && !mixkeyexists) return;
   // only cancelbtn gets us here--mrCancel whether cancel or exit
   if (Notebook->PageIndex>0 && Notebook->PageIndex<3)//CancelBtn->Caption!="Exit")
   {
      if (MsgBoxHwnd(Handle,"Quit without removing QuickSilver?",
         AppName,MB_YESNO)==IDNO)
      {
         CanClose = false;
      }
   }
   if (QSdone && Notebook->ActivePage=="Final")
   {
      Sleep(200); AppProcessMessages(); ExploreFolder(appdir);
      AppProcessMessages(); Sleep(200);
      Close();
   }
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::RemoveSoftware()
{
   RichEdit2->Clear();
   RichEdit2->Enabled = true;
   BackBtn->Enabled = false;
   //NextBtn->Enabled = false;
   CancelBtn->Enabled = false;
   ActiveControl = RichEdit2;
   Application->ProcessMessages();
   if (doappfirst)
   {
      RemoveQuickSilver();
      if (MixEntries->Checked) RemoveMixmaster();
   }
   else
   if (domixfirst)
   {
      RemoveMixmaster();
      if (AppEntries->Checked) RemoveQuickSilver();
   }
   Label4->Caption = "";
   Application->ProcessMessages();
   Label4->Caption = "Un-Installation complete!";
   RichEdit2->Lines->Add("Done!");
   //RichEdit2->Lines->Add("Click 'Finish' to complete the operation.");
   ActiveControl = Panel1;
   //Label6->Caption = "Thanks!";
   MyBeep(MB_OK);
   //if (AppEntries->Checked)
   //   ShowHomeDirWarning(appdir,this);
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::RemoveQuickSilver()
{
   if (!AppEntries->Checked) return;
   RichEdit2->Lines->Add("Removing QuickSilver...");
   Sleep(300);
   RemoveProgGroup();
   RemoveProgFiles();
   RemoveProgEntries();
   QSdone = true;
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::RemoveMixmaster()
{
   if (!MixEntries->Checked) return;
   RichEdit2->Lines->Add("Removing Mixmaster...");
   Sleep(300);
   RemoveMixFiles();
   RemoveMixEntries();
   MXdone = true;
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::LoadReview()
{
   Memo1->Clear();
   Memo1->Lines->Add(AppName + (AppEntries->Checked ? " = YES" : " = NO"));
   Memo1->Lines->Add(AnsiString("Mixmaster") + (MixEntries->Checked ? " = YES" : " = NO"));
   Memo1->Perform(EM_SCROLL,SB_PAGEUP,0);
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::TurnOff(TCheckBox *box)
{
   box->Checked = false;
   box->Enabled = false;
}
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::RemoveProgGroup()
{
   // remove desktop shortcut
   AnsiString shortcut="c:\\windows\\desktop\\quicksilver.lnk";
   if (FileExists(shortcut)) DeleteFile(shortcut.c_str());
   // same for program group
   if (!DDEClient->SetLink("PROGMAN","PROGMAN"))
   {
      MsgBoxHwnd(Handle,"Unable to remove "+AppName+" program group!","Error",MB_OK);
      return false;
   }
   bool ok = true;
   try {
      if (!DDEClient->ExecuteMacro(AnsiString("[DeleteGroup("+proggroup+")]").c_str(),false))
         MsgBoxHwnd(Handle,"ExecuteMacroLines failed!\nUnable to create Program Group!","Program Error",MB_OK);
   }
   catch (...) {
      MsgBoxHwnd(Handle,"Exception caught at ExecuteMacro","Exception",MB_OK);
      DDEClient->CloseLink();
      ok = false;
   }
   if (ok) {
      DDEClient->CloseLink();
   }
   RichEdit2->Lines->Add("   program group...done");
   Application->ProcessMessages();
   Sleep(300);
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::RemoveProgEntries()
{
   TRegistry *reg = new TRegistry();
   reg->DeleteKey(QuickKey);
   delete reg;
   RichEdit2->Lines->Add("   registry key...done");
   Application->ProcessMessages();
   Sleep(300);
   return true;
}
//---------------------------------------------------------------------------
int __fastcall removefile(AnsiString &filename)
{
   int result;
   if (FileExists(filename)) result = DeleteFile(filename.c_str());
   return result;
}
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::DeleteQuickSilverFiles(AnsiString &pathname)
{
   if (pathname.IsEmpty() || !DirectoryExists(pathname)) return false;
   AnsiString thedir=AddBackslash(pathname);
   if (!FileExists(thedir+UninstDat))
   {
      MsgBoxHwnd(Handle,
         s("The QuickSilver uninstall info file "+UninstDat+" is missing! I'll remove\n")+
         s("the program group, desktop shortcut and registry key. You'll need to\n")+
         s("delete the files and directories yourself."),
         s("Uninstall Problem"),
         MB_OK
      );
      return true;
   }
   TStringList *uninstdat = new TStringList();
   // add these for deletion
   uninstdat->LoadFromFile(thedir+UninstDat);
   uninstdat->Add(thedir+UninstDat);
   uninstdat->Add(thedir+SetupLog);

   AnsiString thefile,fname;
   for (int i=0; i<uninstdat->Count; i++)
   {
      thefile = uninstdat->Strings[i].LowerCase();
      fname = ExtractFileName(thefile);
      if (fname!="qs.dbc" && fname!="qs.pgp" && fname!="qs.pgp.bak")
         DeleteFile(thefile.c_str());
   }
   delete uninstdat;

   // delete the updates directory if empty
   if (GetFilenames(NULL,thedir+"updates\\")==0)
      DeleteDirectory(thedir+"updates\\");

   return true;
}
/*
bool __fastcall DeleteQuickSilverFiles(AnsiString &pathname)
{
   if (pathname.IsEmpty() || !DirectoryExists(pathname)) return false;
   int i;
   TSearchRec sr;
   AnsiString del,fname,aname;
   pathname = AddBackslash(pathname);
   TStringList *dirs = new TStringList();
   TStringList *files = new TStringList();

   int done = FindFirst(pathname+"*.*",faAnyFile,sr);
   while (!done)
   {
      if (sr.Name != "." && sr.Name != "..")
      {
         del = pathname+sr.Name;
         if (sr.Attr!=faDirectory) files->Add(del.LowerCase());
         else dirs->Add(del.LowerCase());
      }
      done = FindNext(sr);
   }

   // remove directories
   // for (i=0; i<dirs->Count; i++)
   // {
   //   del = GetShortFileName(dirs->Strings[i]);
   //   if (!DeleteDirectory(del.c_str())) ;
   //      MsgBoxHwnd(Handle,"Unable to delete directory:\n"+del,"Problem",MB_OK);
   // }
   // remove files
   for (i=0; i<files->Count; i++)
   {
      del = files->Strings[i];
      fname = ExtractFileName(del).LowerCase();
      aname = ChangeFileExt(ExtractFileName(AppExe),"").LowerCase();
      if (fname==aname+DatExt ||
          fname==aname+PgpExt ||
          fname==aname+PgpExt+BakExt)
             continue;

      if (!DeleteFile(del.c_str())) ;
      // MsgBoxHwnd(Handle,"Unable to delete file: "+del,"Problem",MB_OK);
   }
   delete files;
   delete dirs;
   return true; //RemoveDirectory(pathname.c_str());
}
*/
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::RemoveProgFiles()
{
   DeleteQuickSilverFiles(appdir);
   RichEdit2->Lines->Add("   program files...done");
   Application->ProcessMessages();
   Sleep(300);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::RemoveMixEntries()
{
   TRegistry *reg = new TRegistry();
   reg->DeleteKey(MixKey);
   delete reg;
   RichEdit2->Lines->Add("   registry key...done");
   Application->ProcessMessages();
   Sleep(300);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::DeleteMixmasterFiles(AnsiString &pathname)
{
   if (pathname.IsEmpty() || !DirectoryExists(pathname)) return false;
   AnsiString thedir = AddBackslash(pathname);
   if (!FileExists(thedir+UninstDat))
   {
      MsgBoxHwnd(Handle,
         s("The Mixmaster uninstall info file "+UninstDat+" is missing! I'll remove\n")+
         s("registry key. You'll need to delete the files and directories."),
         s("Uninstall Problem"),
         MB_OK
      );
      return true;
   }
   TStringList *tmp = new TStringList();
   TStringList *uninstdat = new TStringList();
   uninstdat->LoadFromFile(thedir+UninstDat);
   uninstdat->Add(thedir+UninstDat);
   uninstdat->Add(thedir+"mixrand.bin");
   // add the doc backup files to list
   GetFilenames(tmp,thedir+"rlist*.txt");
   uninstdat->AddStrings(tmp);
   GetFilenames(tmp,thedir+"pubring*.asc");
   uninstdat->AddStrings(tmp);
   GetFilenames(tmp,thedir+"mlist*.txt");
   uninstdat->AddStrings(tmp);
   GetFilenames(tmp,thedir+"pubring*.mix");
   uninstdat->AddStrings(tmp);
   GetFilenames(tmp,thedir+"type2*.list");
   uninstdat->AddStrings(tmp);
   delete tmp;

   for (int i=0; i<uninstdat->Count; i++)
      DeleteFile(uninstdat->Strings[i].c_str());
   delete uninstdat;

   // delete the pool directory if empty
   if (GetFilenames(NULL,thedir+"pool\\*.*")==0)
      DeleteDirectory(thedir+"pool\\");
   // delete mixmaster dir if empty
   if (!DirectoryExists(thedir+"pool\\") && GetFilenames(NULL,thedir)==0)
      DeleteDirectory(thedir);

   return true;
}
/*
bool __fastcall DeleteMixmasterFiles(AnsiString &pathname)
{
   if (pathname.IsEmpty() || !DirectoryExists(pathname)) return false;
   int i;
   TSearchRec sr;
   AnsiString del;
   pathname = AddBackslash(pathname);
   TStringList *dirs = new TStringList();
   TStringList *files = new TStringList();
   int done = FindFirst(pathname+"*.*",faAnyFile,sr);
   while (!done)
   {
      if (sr.Name != "." && sr.Name != "..")
      {
         del = pathname+sr.Name;
         if (sr.Attr!=faDirectory) files->Add(del.LowerCase());
         else dirs->Add(del.LowerCase());
      }
      done = FindNext(sr);
   }
   // remove directories
   // for (i=0; i<dirs->Count; i++)
   // {
   //   del = GetShortFileName(dirs->Strings[i]);
   //   if (!DeleteDirectory(del.c_str())) ;
   //      MsgBoxHwnd(Handle,"Unable to delete directory:\n"+del,"Problem",MB_OK);
   // }
   // remove files
   for (i=0; i<files->Count; i++)
   {
      del = files->Strings[i];
      if (!DeleteFile(del.c_str())) ;
      // MsgBoxHwnd(Handle,"Unable to delete file: "+del,"Problem",MB_OK);
   }
   bool ok = true;
   // sm(dirs->Text);
   int pool = dirs->IndexOf(pathname+"pool");
   if (pool>=0)
   {
      ok = DeleteDirectory(pathname+"pool");
      dirs->Delete(pool);
   }
   if (ok && !dirs->Count)
      ok = RemoveDirectory(pathname.c_str());
   delete files;
   delete dirs;
   return ok;
}
//---------------------------------------------------------------------------
*/
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::RemoveMixFiles()
{
   DeleteMixmasterFiles(AddBackslash(mixdir));
   RichEdit2->Lines->Add("   program files...done");
   Application->ProcessMessages();
   Sleep(300);
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::AppEntriesClick(TObject *Sender)
{
   if (AppEntries->Checked)
   {
      if (MixInApp() || MixIsApp()) { MixEntries->Checked=true; MixEntries->Enabled=false; }
   }
   else
   {
      if (MixIsApp() || MixInApp()) { MixEntries->Enabled=true; }
   //   if (MixInApp()) { MixEntries->Checked=false; MixEntries->Enabled=true; }
   //   if (MixIsApp()) { MixEntries->Enabled=true; }
   }
   NextBtn->Enabled = (AppEntries->Checked || MixEntries->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TUninstWiz::MixEntriesClick(TObject *Sender)
{
   if (MixEntries->Checked) {
      if (AppInMix() || MixIsApp()) { AppEntries->Checked=true; AppEntries->Enabled=false; }
   }
   else
   {
      if (MixIsApp() || AppInMix()) { AppEntries->Enabled=true; }
//      if (AppInMix()) { AppEntries->Checked=false; AppEntries->Enabled=true; }
//      if (MixIsApp()) { AppEntries->Enabled=true; }
   }
   NextBtn->Enabled = (AppEntries->Checked || MixEntries->Checked);
}
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::MixInApp()
{
   AnsiString app,mix;
   if (appkeyexists) app = GetShortFileName(appdir).LowerCase();
   if (mixkeyexists) mix = GetShortFileName(mixdir).LowerCase();
   return !app.IsEmpty() && !mix.IsEmpty() && mix.Length()>app.Length() && mix.Pos(app)==1;
}
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::AppInMix()
{
   AnsiString app,mix;
   if (appkeyexists) app = GetShortFileName(appdir).LowerCase();
   if (mixkeyexists) mix = GetShortFileName(mixdir).LowerCase();
   return !app.IsEmpty() && !mix.IsEmpty() && app.Length()>mix.Length() && app.Pos(mix)==1;
}
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::MixIsApp()
{
   AnsiString app,mix;
   if (appkeyexists) app = GetShortFileName(appdir).LowerCase();
   if (mixkeyexists) mix = GetShortFileName(mixdir).LowerCase();
   return !app.IsEmpty() && !mix.IsEmpty() && app==mix;
}
//---------------------------------------------------------------------------
bool __fastcall TUninstWiz::MixIsSep()
{
   AnsiString app,mix;
   if (appkeyexists) app = GetShortFileName(appdir).LowerCase();
   if (mixkeyexists) mix = GetShortFileName(mixdir).LowerCase();
   return !app.IsEmpty() &&
          !mix.IsEmpty() &&
          !MixInApp() &&
          !MixIsApp() &&
          !AppInMix() &&
           app!=mix;
}
//---------------------------------------------------------------------------
